.global main
.include "carte.inc"
.text
.align
main:

/* enable the clock */
	ldr r0, = PMC_BASE
	ldr r1, =0x101
	str r1, [r0, #PMC_IDR]    /* interrupts are disabled */
	ldr r6, [r0, #PMC_IMR]    /* Reading the interrupt status */ /* why is the interrupt not getting disabled????? */
	ldr r1, =0x101
	str r1, [r0, #CKGR_MOR]   /* configuring the main oscillator for the main clock */
	ldr r4, [r0, #CKGR_MCFR]  /* reading the frequency of the oscillator */
	ldr r1, =0x10201
	str r1, [r0, #CKGR_PLLR]  /* configuring the PLL */
	mov r1, #0x700
	str r1, [r0, #PMC_SCDR]   /* diables the programmable clock outputs */
	ldr r1, =0x400
	str r1, [r0, #PMC_PCER]   /* enables PWM as defined in the peripheral identifiers */
	mov r1, #0x1
	str r1, [r0, #PMC_MCKR]   /* Main Clock is selected */
	


	ldr r0, =PIOB_BASE
	mov r1, #0x78000000
	str r1, [r0, #PIO_PDR]  /* gives these pins to peripheral control(PWM pins) */
	str r1, [r0, #PIO_BSR]  /* gives these pins to peripheral B */

	


	ldr r0, =PWMC_BASE
	mov r1, #0x0
	str r1, [r0, #PWM_MR]    /* CLKA and CLKB are turned off */
	ldr r1, =0x101
	str r1, [r0, #PWM_CMR0]  /* configuring the channel mode for PWM0- MCK/2, centre aligned, CPD = 0 */
	ldr r1, =0x102
	str r1, [r0, #PWM_CMR1]  /* configuring the channel mode for PWM1- MCK/4, centre aligned, CPD = 0  */
	ldr r1, =0x103
	str r1, [r0, #PWM_CMR2]  /* configuring the channel mode for PWM2- MCK/8, centre aligned, CPD = 0  */
	ldr r1, =0x104
	str r1, [r0, #PWM_CMR3]  /* configuring the channel mode for PWM3- MCK/16, centre aligned, CPD = 0  */
	ldr r1, =0x4C4B40	 /* period register(5,000,000) */
	str r1, [r0, #PWM_CPRD0] /* configuring the period register for PWM0 */
	str r1, [r0, #PWM_CPRD1] /* configuring the period register for PWM1 */
	str r1, [r0, #PWM_CPRD2] /* configuring the period register for PWM2 */
	str r1, [r0, #PWM_CPRD3] /* configuring the period register for PWM3 */
	ldr r1, =0x1E8480	 /* duty cycle (2,000,000) */
	str r1, [r0, #PWM_CDTY0] /* configuring the duty cycle for PWM0 */
	str r1, [r0, #PWM_CDTY1] /* configuring the duty cycle for PWM1 */
	str r1, [r0, #PWM_CDTY2] /* configuring the duty cycle for PWM2 */
	str r1, [r0, #PWM_CDTY3] /* configuring the duty cycle for PWM3 */
	mov r1, #0xF
	str r1, [r0, #PWM_IDR]   /* disabling the interrup(ts for all the four channels */
	ldr r1, =0x1E8480	 /* duty cycle (2,000,000) */
	str r1, [r0, #PWM_CUPD0] /* configuring the update register for PWM0 */
	str r1, [r0, #PWM_CUPD1] /* configuring the update register for PWM1 */
	str r1, [r0, #PWM_CUPD2] /* configuring the update register for PWM2 */
	str r1, [r0, #PWM_CUPD3] /* configuring the update register for PWM3 */
	mov r1, #0xF
	str r1, [r0, #PWM_ENA]  /* enabling the PWM outpput for all the four channels */
	



	






	
exit:
	b exit




